//#########################################################################
// softspi.h
//
//#########################################################################
// Last change: 13.02.2008
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 4.1.1
//#########################################################################

#ifndef SOFT_SPI_H
#define SOFT_SPI_H

#define SOFT_SPI_PORT	PORTA
#define SOFT_SPI_DDR	DDRA
#define SOFT_SPI_PIN	PINA
#define SOFT_SPI_SCK	0	// Pinnumber for SCK
#define SOFT_SPI_IN	1	// Pinnumber for MISO
#define SOFT_SPI_OUT	2	// Pinnumber for MOSI	

#define ADNS_CONFIG		0x00
#define ADNS_STATUS		0x01
#define ADNS_DELTA_Y		0x02
#define ADNS_DELTA_X		0x03
#define ADNS_SQUAL		0x04
#define ADNS_MAX_PIXEL		0x05
#define ADNS_MIN_PIXEL		0x06
#define ADNS_PIXEL_SUM		0x07
#define ADNS_PIXEL_DATA		0x08
#define ADNS_SHUTTER_UPPER	0x09
#define ADNS_SHUTTER_LOWER	0x0A
#define ADNS_INVERSE_PRODUKT	0x11

#define START_OF_FRAME		0x80
#define VALID_DATA		0x40

// Some usefull defines
#define NOP	 asm volatile ("nop" ::)
#define sbi(portn, bitn) ((portn)|=(1<<(bitn)))
#define cbi(portn, bitn) ((portn)&=~(1<<(bitn)))

void soft_spi_init(void);
void soft_spi_write(unsigned char dat);
unsigned char soft_spi_read(void);
unsigned char ADNSRead(unsigned char adr);
void ADNSWrite(unsigned char adr, unsigned char data);

void Delay1ms(unsigned int time);
void Delay1us(unsigned int time);

#endif
